#!/usr/bin/perl

$config="/etc/bforce/sln_sf.conf";


##############################################################################
use DB_File;

my $i=0;
my $j=0;
open(CFG, "< $config") || die $!;
while($_=<CFG>){

$accdb=$1	if /^accessdb[\t\s]+(.+)$/i;
$dirdb=$1	if /^pathdb[\t\s]+(.+)$/i;
$filedb=$1	if /^filedb[\t\s]+(.+)$/i;
$aliasdb=$1	if /^aliasdb[\t\s]+(.+)$/i;

$alias_tmp{$1}=$2, $j++ 		if /^alias[\t\s]+(\S+)[\t\s]+(.+)$/i;
$dir_tmp{$i}=$1, $acc_tmp{$i}=$2, $i++	if /^(\/\S+)[\t\s]+(\d+)/;
}
close CFG;

print "Found $i directories for file request and $j aliases:\n";

dbmopen(my %dir,   $dirdb,   0600) || die $!;
dbmopen(my %acc,   $accdb,   0600) || die $!;
dbmopen(my %alias, $aliasdb, 0600) || die $!;
dbmopen(my %file,  $filedb,  0600) || die $!;

%dir=%dir_tmp;
%acc=%acc_tmp;
%alias=%alias_tmp;
undef %file;

foreach my $cnt (sort{$a<=>$b} keys %dir){
opendir(D, $dir{$cnt}) || die $!;
$file{$cnt}=join "\0", grep{-f "$dir{$cnt}/$_" and !/\.bbs$/i} readdir D;
closedir D;

print "Process $dir{$cnt} "."."x(55-length $dir{$cnt}).sprintf("%4s",scalar split /\0/,$file{$cnt})." files\n";
}

dbmclose %file;
dbmclose %alias;
dbmclose %acc;
dbmclose %dir;

print "Ok, data base created success!\n";
